=== source/3rdparty/CMakeLists.txt ===

# External libraries
add_subdirectory(KHR)
