=== source/tools/CMakeLists.txt ===

#
# Tools
#

# OpenGL Tools
add_subdirectory("glcontexts")
add_subdirectory("glfunctions")
add_subdirectory("glinfo")
add_subdirectory("glisdeprecated")
add_subdirectory("glmeta")
add_subdirectory("glqueries")

# OpenGL ES Compatability Tools
add_subdirectory("glescontexts")
