=== debian/changelog ===
glbinding (3.3.0-3) unstable; urgency=medium

  * Team upload.
  * Migrate debian/watch to version 5 format
  * Fix FTBFS with CMake 4 (Closes: #1112958)
  * Fix autopkgtest

 -- Timo Röhling <roehling@debian.org>  Thu, 16 Oct 2025 15:28:27 +0200

glbinding (3.3.0-2) unstable; urgency=medium

  * Team upload.
  * [951ff24] Fix glbinding-config.cmake

 -- Anton Gladky <gladk@debian.org>  Wed, 11 Dec 2024 18:40:48 +0100

glbinding (3.3.0-1) unstable; urgency=medium

  [ Andreas Tille ]
  * Team upload.
  * New upstream version
    Closes: #951805
  * New upstream requires SONAME bump
  * Standards-Version: 4.7.0 (routine-update)
  * debhelper-compat 13 (routine-update)
  * Reorder sequence of d/control fields by cme (routine-update)
  * Remove trailing whitespace in debian/control (routine-update)
  * Remove trailing whitespace in debian/copyright (routine-update)
  * Rules-Requires-Root: no (routine-update)
  * Update renamed lintian tag names in lintian overrides.
  * Remove unnecessary 'Testsuite: autopkgtest' header.
  * Remove obsolete field Name from debian/upstream/metadata
    (already present in machine-readable debian/copyright).
  * Replace use of deprecated $ADTTMP with $AUTOPKGTEST_TMP.
  * Avoid explicitly specifying -Wl,--as-needed linker flag.
  * Remove constraints unnecessary since bullseye (oldstable):
    + libglbinding-dev: Replace dependency on transitional package
      libgl1-mesa-dev with replacement libgl-dev, libglvnd-dev in Depends.
  * watch file standard 4 (routine-update)
  * d/copyright: review for new version
  * Adapt autopkgtest to new upstream version
  FIXME: cmake fails if libglfw3-dev is installed

  [ Anton Gladky ]
  * Fix autopkgtests.

 -- Andreas Tille <tille@debian.org>  Wed, 27 Nov 2024 11:16:20 +0100

glbinding (2.1.1-2) unstable; urgency=medium

  * Team upload
  * Allow output to stderr, because of new cmake complaining
    wrt CMP0037 being deprecated

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 04 Jul 2018 10:47:32 +0200
