=== debian/control ===
Source: glbinding
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Ghislain Antony Vaillant <ghisvail@gmail.com>
Section: libs
Priority: optional
Build-Depends: cmake,
               debhelper-compat (= 13),
               libglfw3-dev
Build-Depends-Indep: doxygen,
                     graphviz
Standards-Version: 4.7.0
Vcs-Browser: https://salsa.debian.org/science-team/glbinding
Vcs-Git: https://salsa.debian.org/science-team/glbinding.git
Homepage: https://github.com/cginternals/glbinding
Rules-Requires-Root: no

Package: libglbinding3
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: cross-platform C++ binding for OpenGL
 glbinding leverages modern C++11 features like enum classes,
 lambdas, and variadic templates, instead of relying on macros;
 all OpenGL symbols are real functions and variables.
 .
 It provides type-safe parameters, per feature API header, lazy
 function resolution, multi-context and multi-thread support,
 global and local function callbacks, meta information about the
 generated OpenGL binding and the OpenGL runtime, as well as tools
 and examples for quick-starting your projects.
 .
 This package provides the shared libraries.

Package: libglbinding-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: ${misc:Depends},
         libgl-dev, libglvnd-dev | libgl-dev,
         libglbinding3 (= ${binary:Version})
Suggests: glbinding-doc
Description: development files for glbinding
 glbinding leverages modern C++11 features like enum classes,
 lambdas, and variadic templates, instead of relying on macros;
 all OpenGL symbols are real functions and variables.
 .
 It provides type-safe parameters, per feature API header, lazy
 function resolution, multi-context and multi-thread support,
 global and local function callbacks, meta information about the
 generated OpenGL binding and the OpenGL runtime, as well as tools
 and examples for quick-starting your projects.
 .
 This package provides the development files.

Package: glbinding-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: ${misc:Depends},
         fonts-font-awesome,
         libjs-bootstrap,
         libjs-jquery
Description: documentation for glbinding
 glbinding leverages modern C++11 features like enum classes,
 lambdas, and variadic templates, instead of relying on macros;
 all OpenGL symbols are real functions and variables.
 .
 It provides type-safe parameters, per feature API header, lazy
 function resolution, multi-context and multi-thread support,
 global and local function callbacks, meta information about the
 generated OpenGL binding and the OpenGL runtime, as well as tools
 and examples for quick-starting your projects.
 .
 This package provides the documentation.

Package: glbinding-tools
Architecture: any
Multi-Arch: foreign
Section: utils
Depends: ${misc:Depends},
         ${shlibs:Depends},
         libglbinding3 (= ${binary:Version})
Description: command-line tools for glbinding
 glbinding leverages modern C++11 features like enum classes,
 lambdas, and variadic templates, instead of relying on macros;
 all OpenGL symbols are real functions and variables.
 .
 It provides type-safe parameters, per feature API header, lazy
 function resolution, multi-context and multi-thread support,
 global and local function callbacks, meta information about the
 generated OpenGL binding and the OpenGL runtime, as well as tools
 and examples for quick-starting your projects.
 .
 This package provides the command-line tools.
