=== debian/tests/control ===
Tests: run-unit-test
Depends: cmake,
         g++ | c++-compiler,
         googletest,
         libglbinding-dev,
         libglfw3-dev,
         libgtest-dev,
         libgmock-dev
Restrictions: allow-stderr
