=== debian/watch ===
Version: 5

Template: Github
Owner: cginternals
Project: glbinding
